module.exports = {
    "extends": "airbnb",
    "plugins": [
        "react",
        "jsx-a11y",
        "import"
    ],
    "parser": "babel-eslint",
    "env": {
        "browser": true,
        "node": true,
        "es6": true
    },
    "rules": {
        "no-else-return": "off",
        "no-eq-null": 2,
        "no-extra-parens": 0,
        "no-floating-decimal": 2,
        "no-inner-declarations": [2, "both"],
        "no-lonely-if": 2,
        "no-multiple-empty-lines": [2, {"max": 3}],
        "no-self-compare": 2,
        "no-underscore-dangle": 0,
        "no-use-before-define": 0,
        "no-unused-expressions": "warn",
        "no-useless-concat": "warn",
        "no-underscore-dangle": "off",
        "no-console": "off", // TODO: remove during production,
        "no-case-declarations": "off",
        "no-param-reassign": "off",
        "no-plusplus": "off",
        "no-else-return": "off",
        "no-void": 2,
        "no-mixed-operators": "off",
        "brace-style": [2, "1tbs"],
        "camelcase": [1, {"properties": "never"}],
        "consistent-return": 0,
        "comma-style": [2, "last"],
        "complexity": [1, 12],
        "func-names": 0,
        "guard-for-in": 2,
        "max-len": [0, 120, 4],
        "new-cap": [2, {"newIsCap": true, "capIsNew": false}],
        "quotes": "off",
        "keyword-spacing": [2, {"before": true, "after": true}],
        "space-before-blocks": [2, "always"],
        "array-bracket-spacing": [2, "never"],
        "space-in-parens": [2, "never"],
        "strict": [0],
        "valid-jsdoc": 2,
        "wrap-iife": [2, "any"],
        "yoda": [1, "never"],
        "arrow-parens": "off",
        "comma-dangle": ["warn", "never"],
        "indent": ["warn", 2],
        "linebreak-style": ["warn","unix"],
        "semi": ["error", "always"],
        "block-scoped-var": "error",
        "consistent-return": "error",
        "arrow-parens": ["error", "as-needed"],
        "jsx-a11y/img-has-alt": "off",
        "import/no-extraneous-dependencies": "off",
        "import/extensions": "off",
        "import/no-unresolved": "off",
        "indent": [2, 2, {"SwitchCase": 1}],
        "prefer-const": "off",
        "jsx-quotes": "off",
        "react/prop-types": [2, { ignore: ['location', 'router', 'children']}],
        "import/prefer-default-export": "off",
        "consistent-return": "off",
        "class-methods-use-this": "off",
        "jsx-a11y/no-static-element-interactions": "off",
        "react/no-danger": "off"
    }
}